////////////////////////////////////////////////////////////////////////////////
///
///		Title		: Timer File
///
///		Copyright (c) 2006, NHN Co., Ltd. ALL RIGHTS RESERVED
///
///		Team		: Desktop Service Development
///
////////////////////////////////////////////////////////////////////////////////
#pragma once


/**
* @ingroup 	Base UI	
* @brief 	
* @date		11/07/2006
* @author	telltale
* @remark	{kr} Ÿ̸Ӱ  ȣǴ ̽ 
			- OnTimer  ȣȴ.
			- ڷ Ÿ̸ ̵ ѾԵȴ. {/kr}
*/
interface INPTimerHandler
{
public:	
	/**
	* @brief 	whenever timer bomb
	* @param	dwTimerID	timer's id
	* @return	if this function succeeds, return TRUE
	*/
	virtual  BOOL OnTimer( DWORD dwTimerID) = 0;	
};
/**
* @ingroup 	Base UI	
* @brief 	Timer class
* @date		11/07/2006
* @author	telltale
* @remark	
*/
class CNPTimer
{
public:
	CNPTimer(void);
	~CNPTimer(void);
	/**
	* @brief				{kr}	Ÿ̸ Ŭ settingѴ. {/kr}
	* @param dwStartDueTime	{kr}	Timer  ð 帥 ۵ȴ. {/kr}
	* @param dwPeriod		{kr}	Timer  {/kr}
	* @param dwTid			{kr}	Timer ID {/kr}
	* @param pHandler		{kr}	ITimerHandler Ÿ̸Ӱ Ŀ ȣ ̽ {/kr}
	* @param flags			{kr}	flag {/kr}
	* @return				if this function succeeds, return TRUE
	*/
	BOOL SetTimer(DWORD dwStartDueTime, DWORD dwPeriod, DWORD dwTid, INPTimerHandler* pHandler, ULONG uFlag = 0);
	/**
	* @brief {kr} Ÿ̸ Ŭ stopѴ. {/kr}
	* @return				if this function succeeds, return TRUE
	*/
	BOOL StopTimer();
	/**
	* @brief {kr} Ÿ̸Ӱ   ȣȴ. ο ITimerHander ȣѴ. {/kr}
	* @param pvContext		{kr} Ѱ   {/kr}
	* @param TimerOrWaitFired	{kr} ׻ TRUE {/kr}
	* @return none
	*/
	static VOID CALLBACK fnCallback(PVOID pvContext, BOOLEAN TimerOrWaitFired);
	/**
	* @brief	{kr} Ÿ̸ ڵ鷯  ´.	{/kr}
	* @return	{kr} Pointer to ITimerHandler {/kr}
	*/
	INPTimerHandler* GetTimerHandler() { return m_pHandler; }

	/**
	* @brief	{kr} Ÿ̸ ID  ´. {/kr}
	* @return	{kr} Ÿ̸ ̵{/kr}
	*/
	DWORD GetTimerID() { return m_dwTid; }

private:
	///< timer period in millisec
	DWORD  m_dwPeriod;			
	///< timer handle
	HANDLE m_hTimer;			
	///< timer ID
	DWORD  m_dwTid;				
	///< Timer Handler
	INPTimerHandler* m_pHandler;	

	BOOL IsAvailable() { return m_hTimer != INVALID_HANDLE_VALUE &&
								m_pHandler != NULL ; }
};
